package httpload;

import java.util.*;

import org.apache.commons.httpclient.*;
import org.apache.commons.httpclient.methods.*;

/**
 *	1NGXgi[NX
 */
public class HttpLoadRequest
{
	/** \bh */
	private String method;

	/** URL */
	private String url;

	/** p[^ */
	private Hashtable param;

	/** [UID */
	private String userId;

	/** pX[h */
	private String password;

	/** ̈(realm) */
	private String realm;

	/**
	 *	ftHgRXgN^
	 */
	public HttpLoadRequest()
	{
		this("", "", new Hashtable());
	}

	/**
	 *	1NGXg𐶐
	 *
	 *	@param	method	\bh(GET or POST)
	 *	@param	url
	 */
	public HttpLoadRequest(String method, String url)
	{
		this(method, url, new Hashtable());
	}

	/**
	 *	1NGXg𐶐
	 *
	 *	@param	method	\bh(GET or POST)
	 *	@param	url		URL
	 *	@param	param	p[^
	 */
	public HttpLoadRequest(String method, String url, Hashtable param)
	{
		this.method = method;
		this.url = url;
		this.param = param;
		this.userId = "";
		this.password = "";
		this.realm = "";
	}

	/**
	 *	GET\bh쐬
	 */
	private static HttpMethod createGetMethod(String url)
	{
		return createGetMethod(url, null);
	}

	/**
	 *	GET\bh쐬
	 */
	private static HttpMethod createGetMethod(String url, Hashtable param)
	{
		GetMethod method = new GetMethod(url);

		// p[^GET\bhɃZbg
		if(param != null && param.size() != 0)
		{
			method.setQueryString(convert(param));
		}

		return method;
	}

	/**
	 *	POST\bh쐬
	 */
	private static HttpMethod createPostMethod(String url)
	{
		return createPostMethod(url, null);
	}

	/**
	 *	POST\bh쐬
	 */
	private static HttpMethod createPostMethod(String url, Hashtable param)
	{
		PostMethod method = new PostMethod(url);

		// p[^POST\bhɃZbg
		if(param != null && param.size() != 0)
		{
			method.setRequestBody(convert(param));
		}

		return method;
	}

	/**
	 *	Hashtable  NameValuePair[]ϊ
	 */
	private static NameValuePair[] convert(Hashtable param)
	{
		Vector paramList = new Vector();
		Iterator ite = param.keySet().iterator();
		while(ite.hasNext())
		{
			String key = (String)ite.next();
			String value = (String)param.get(key);
			paramList.add(new NameValuePair(key, value));
		}

		// Vector  zϊ
		NameValuePair[] paramListArray = new NameValuePair[paramList.size()];
		paramList.toArray(paramListArray);

		return paramListArray;
	}

	/**
	 *	NGXg\bh̎擾
	 */
	public HttpMethod getHttpMethod()
	{
		HttpMethod result = null;
		if(method.equals("GET"))
		{
			result = createGetMethod(url, param);
		}
		else if(method.equals("POST"))
		{
			result = createPostMethod(url, param);
		}
		else
		{
			result = null;
		}

		return result;
	}

	/**
	 *	\bh擾
	 */
	public String getMethod()
	{
		return method;
	}

	/**
	 *	\bhZbg
	 */
	public void setMethod(String method)
	{
		this.method = method;
	}

	/**
	 *	URL擾
	 */
	public String getUrl()
	{
		return url;
	}

	/**
	 *	URLZbg
	 */
	public void setUrl(String url)
	{
		this.url = url;
	}

	/**
	 *	p[^擾
	 */
	public Hashtable getParam()
	{
		return param;
	}

	/**
	 *	p[^Zbg
	 */
	public void addParam(String key, String value)
	{
		param.put(key, value);
	}

	/**
	 *	[UID擾
	 */
	public String getUserId()
	{
		return userId;
	}

	/**
	 *	[UIDZbg
	 */
	public void setUserId(String userId)
	{
		this.userId = userId;
	}

	/**
	 *	pX[h擾
	 */
	public String getPassword()
	{
		return password;
	}

	/**
	 *	pX[hZbg
	 */
	public void setPassword(String password)
	{
		this.password = password;
	}

	/**
	 *	̈擾
	 */
	public String getRealm()
	{
		return realm;
	}

	/**
	 *	̈Zbg
	 */
	public void setRealm(String realm)
	{
		this.realm = realm;
	}
}
