package httpload;

import java.io.IOException;
import java.util.*;
import java.net.URL;

import org.apache.commons.httpclient.*;

import httpload.util.StringUtil;

/**
 *	ViI̊eXebv\NX
 */
public class HttpLoadStep
{
	/** NGXg */
	private HttpLoadRequest request;

	/** X|X */
	private HttpLoadResponse[] response;

	/**  */
	private HttpLoadValidate validate;

	/** Xebv̌JԂ */
	private int numRepeat;

	/**
	 *	ftHgRXgN^
	 */
	public HttpLoadStep()
	{
		this.request = null;
		this.response = null;
		this.validate = null;
		this.numRepeat = 1;
	}

	/**
	 *	NGXgw肵č\z
	 *
	 *	@param	request		NGXg
	 */
	public HttpLoadStep(HttpLoadRequest request)
	{
		this.request = request;
		this.response = null;
		this.validate = null;
		this.numRepeat = 1;
	}

	/**
	 *	NGXgƌ؂w肵č\z
	 *
	 *	@param	request		NGXg
	 *	@param	validate	
	 */
	public HttpLoadStep(HttpLoadRequest request, HttpLoadValidate validate)
	{
		this.request = request;
		this.response = null;
		this.validate = validate;
		this.numRepeat = 1;
	}

	/**
	 *	NGXgƌJԂ񐔂w肵č\z
	 *
	 *	@param	request		NGXg
	 *	@param	numRepeat	JԂ
	 */
	public HttpLoadStep(HttpLoadRequest request, int numRepeat)
	{
		this.request = request;
		this.response = null;
		this.validate = null;
		this.numRepeat = numRepeat;
	}

	/**
	 *	NGXgƌ؂ƌJԂ񐔂w肵č\z
	 *
	 *	@param	request		NGXg
	 *	@param	validate	
	 *	@param	numRepeat	JԂ
	 */
	public HttpLoadStep(HttpLoadRequest request, HttpLoadValidate validate, int numRepeat)
	{
		this.request = request;
		this.response = null;
		this.validate = validate;
		this.numRepeat = numRepeat;
	}

	/**
	 *	Xebv̎s
	 */
	void execute(HttpClient client)
	{
		try
		{
			Vector responseArray = new Vector();

			for(int i=0; i<numRepeat; i++)
			{
				// 
				HttpMethod method = request.getHttpMethod();
				HttpLoadResponse response = new HttpLoadResponse();

				// [UIDуpX[hłȂꍇAF؂LɂB
				if(request.getUserId().length() != 0 && request.getPassword().length() != 0)
				{
					client.getState().setCredentials(
						request.getRealm(),
						new URL(request.getUrl()).getHost(),
						new UsernamePasswordCredentials(request.getUserId(), request.getPassword())
					);

					method.setDoAuthentication(true);
				}

				// NGXg̎s
				long preRequest = System.currentTimeMillis();
				client.executeMethod(method);
				long postRequest = System.currentTimeMillis();
				response.setResponseTime(postRequest - preRequest);

				// Xe[^XR[h̎擾
				int statusCode = method.getStatusCode();
				response.setStatusCode(statusCode);

				// wb_̎擾
				Header[] headers = method.getResponseHeaders();
				response.setHeaders(headers);

				// ʂ̎擾
				byte[] responseBody = method.getResponseBody();
				response.setContents(responseBody);

				// ؂̎s
				boolean isValidateOk = true;
				HttpLoadValidate validate = getHttpLoadValidate();
				if(validate != null)
				{
					String strResponseBody = new String(responseBody);
					if(	statusCode == validate.getStatusCode())
					{
						// ؕ(}b`)
						String[] patterns = validate.getString();
						for(int j=0; j<patterns.length; j++)
						{
							if(!StringUtil.match(strResponseBody, patterns[j]))
							{
								isValidateOk = false;
								break;
							}
						}

						// ؕ(A}b`)
						String[] unmatchPatterns = validate.getUnmatchString();
						for(int j=0; j<unmatchPatterns.length; j++)
						{
							if(StringUtil.match(strResponseBody, unmatchPatterns[j]))
							{
								isValidateOk = false;
								break;
							}
						}
					}
					else
					{
						isValidateOk = false;
					}
				}
				response.setIsValidateOk(isValidateOk);

				// ʊi[
				responseArray.add(response);

				// N[Y
				method.releaseConnection();
			}

			this.response = new HttpLoadResponse[responseArray.size()];
			responseArray.toArray(this.response);
		}
		catch(IOException io_ex)
		{
			io_ex.printStackTrace();
		}
	}

	/**
	 *	NGXg擾
	 */
	public HttpLoadRequest getHttpLoadRequest()
	{
		return request;
	}

	/**
	 *	NGXgZbg
	 */
	public void setHttpLoadRequest(HttpLoadRequest request)
	{
		this.request = request;
	}

	/**
	 *	X|X擾
	 */
	public HttpLoadResponse[] getHttpLoadResponse()
	{
		return response;
	}

	/**
	 *	X|XZbg
	 */
	public void setHttpLoadResponse(HttpLoadResponse[] response)
	{
		this.response = response;
	}

	/**
	 *	؂擾
	 */
	public HttpLoadValidate getHttpLoadValidate()
	{
		return validate;
	}

	/**
	 *	؂Zbg
	 */
	public void setHttpLoadValidate(HttpLoadValidate validate)
	{
		this.validate = validate;
	}

	/**
	 *	Xebv̌JԂ񐔂̎擾
	 */
	public int getNumRepeat()
	{
		return numRepeat;
	}

	/**
	 *	Xebv̌JԂ񐔂̃Zbg
	 */
	public void setNumRepeat(int numRepeat)
	{
		this.numRepeat = numRepeat;
	}
}
