package httpload.config;

import java.io.*;

import org.xml.sax.*;
import org.apache.commons.digester.*;

import httpload.*;

/**
 *	XML`̐ݒt@CǂݍރNX
 */
public class ConfigReader
{
	public static HttpLoadScenario readConfig(File file) throws IOException, SAXException
	{
		Digester d = new Digester();
		d.setValidating(false);

		// /scenario
		d.addObjectCreate("scenario", HttpLoadScenario.class);
		d.addSetProperties("scenario");

		// /scenario/step
		d.addObjectCreate("scenario/step", HttpLoadStep.class);
		d.addSetProperties("scenario/step");
		d.addSetNext("scenario/step", "addStep");

		// /scenario/step/request
		d.addObjectCreate("scenario/step/request", HttpLoadRequest.class);
		d.addSetProperties("scenario/step/request");
		d.addSetNext("scenario/step/request", "setHttpLoadRequest");

		// /scenario/step/request/params/param
		d.addCallMethod("scenario/step/request/params/param", "addParam", 2);
		d.addCallParam("scenario/step/request/params/param", 0, "name");
		d.addCallParam("scenario/step/request/params/param", 1, "value");

		// /scenario/step/validate
		d.addObjectCreate("scenario/step/validate", HttpLoadValidate.class);
		d.addSetProperties("scenario/step/validate");
		d.addCallMethod("scenario/step/validate/match", "addString", 1);
		d.addCallParam("scenario/step/validate/match", 0, "pattern");
		d.addCallMethod("scenario/step/validate/unmatch", "addUnmatchString", 1);
		d.addCallParam("scenario/step/validate/unmatch", 0, "pattern");
		d.addSetNext("scenario/step/validate", "setHttpLoadValidate");

		HttpLoadScenario scenario = (HttpLoadScenario)d.parse(file);
		return scenario;
	}
}
