package httpload.output;

import java.io.*;
import java.util.*;

import httpload.*;

/**
 *	ʂCSVt@Cɏo͂NX
 */
public class CSVOutput implements HttpLoadOutput
{
	/**
	 *	Observer#updatẽI[oCh
	 */
	public void update(Observable obj, Object arg)
	{
		HttpLoadScenario scenario = (HttpLoadScenario)obj;
		output(scenario);
	}

	/**
	 *	ʏo͏
	 */
	public void output(HttpLoadScenario scenario)
	{
		// ݏ́A1Xbĥݎs\ (łȂƏo͂邽)
		synchronized(httpload.output.CSVOutput.class)
		{
			PrintWriter writer = null;
			try
			{
				// o͏
				File file = new File(scenario.getName() + ".csv");
				boolean isFileExist = file.exists();

				writer = new PrintWriter(new FileWriter(file, true));
				HttpLoadStep[] steps = scenario.getStep();
				Vector lineData = null;

				// y[WԍAURLAp[^̏o
				if(!isFileExist)
				{
					writer.println("Page,URL,Param");
					for(int i=0; i<steps.length; i++)
					{
						// f[^
						HttpLoadRequest anRequest = steps[i].getHttpLoadRequest();

						// 1s̃f[^i[
						lineData = new Vector();

						// y[Wԍ
						lineData.add("\"" + (i+1) + "\"");
						// URL
						lineData.add("\"" + anRequest.getUrl() + "\"");
						// p[^
						lineData.add("\"" + anRequest.getParam().toString() + "\"");

						// sf[^CSVo
						outputVector(lineData, writer);
					}

					// s
					writer.println("");

					// Xe[^XR[hAԁA،ʂ̏o
					// wb_1
					lineData = new Vector();
					for(int i=0; i<steps.length; i++)
					{
						// y[Wԍ
						lineData.add("\"" + "Page" + (i+1) + "\"");
						//  x 2
						for(int j=0; j<2; j++)
							lineData.add("");
					}
					outputVector(lineData, writer);

					// wb_2
					lineData = new Vector();
					for(int i=0; i<steps.length; i++)
					{
						// StatusCode
						lineData.add("\"" + "StatusCode" + "\"");
						// ResponseTime
						lineData.add("\"" + "ResponseTime" + "\"");
						// Validation
						lineData.add("\"" + "Validation" + "\"");
					}
					outputVector(lineData, writer);
				}

				// f[^
				lineData = new Vector();
				for(int i=0; i<steps.length; i++)
				{
					HttpLoadResponse[] anResponse = steps[i].getHttpLoadResponse();

					int maxStatusCode = 0;
					long sumResponseTime = 0;
					boolean isValidateOk = true;

					// 񓯈ꃊNGXgJԂꍇ́A̕ς
					for(int j=0; j<anResponse.length; j++)
					{
						maxStatusCode = anResponse[j].getStatusCode() > maxStatusCode ? anResponse[j].getStatusCode() : maxStatusCode;
						sumResponseTime += anResponse[j].getResponseTime();
						isValidateOk = isValidateOk & anResponse[j].isValidateOk();
					}

					// Xe[^XR[hƉԂƌ،ʂ͖sǉ
					lineData.add("\"" + maxStatusCode + "\"");
					lineData.add("\"" + sumResponseTime + "\"");
					lineData.add("\"" + isValidateOk + "\"");

					// Rec̏o
					if(scenario.isContentsSave())
					{
						outputContents(anResponse[0].getContents(), i);
					}
				}
				outputVector(lineData, writer);
			}
			catch(IOException io_ex)
			{
				io_ex.printStackTrace();
				throw new RuntimeException("IOException!");
			}
			finally
			{
				if(writer != null)
				{
					writer.close();
				}
			}
		}
	}

	/**
	 *	VectorɊi[Ăf[^ɂāAJ}tAo͂B
	 */
	private void outputVector(Vector lineData, PrintWriter writer) throws IOException
	{
		for(int i=0; i<lineData.size(); i++)
		{
			writer.print(lineData.get(i));
			if(i != lineData.size() - 1)
			{
				writer.print(",");
			}
			else
			{
				writer.println("");
				writer.flush();
			}
		}
	}

	/**
	 *	Rec̏o
	 */
	private void outputContents(byte[] contents, int index) throws IOException
	{
		File file = new File("page" + (index+1) + ".html");
		boolean isFileExists = file.exists();

		if(!isFileExists)
		{
			PrintWriter writer = new PrintWriter(new FileWriter(file));
			writer.println(new String(contents));
			writer.close();
		}
	}
}
